#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

struct buffer_t
{
    spvUnsafeArray<float4x4, 50> u_Palatte;
    float4x4 u_Model;
    float4x4 u_TransposeInvModel;
    float4x4 u_MVP;
};

struct main0_out
{
    float2 g_vary_uv0 [[user(locn0)]];
    float3 g_vary_WorldPosition [[user(locn1)]];
    float3 g_vary_WorldNormal [[user(locn2)]];
    float4 v_gl_pos [[user(locn3)]];
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 attPosition [[attribute(0)]];
    float3 attNormal [[attribute(1)]];
    float2 attTexcoord0 [[attribute(2)]];
    float4 attBoneIds [[attribute(3)]];
    float4 attWeights [[attribute(4)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    out.g_vary_uv0 = in.attTexcoord0;
    float4x4 _53 = buffer.u_Palatte[int(in.attBoneIds.x)] * in.attWeights.x;
    float4x4 _62 = buffer.u_Palatte[int(in.attBoneIds.y)] * in.attWeights.y;
    float4x4 _85 = buffer.u_Palatte[int(in.attBoneIds.z)] * in.attWeights.z;
    float4x4 _108 = buffer.u_Palatte[int(in.attBoneIds.w)] * in.attWeights.w;
    float4x4 _122 = float4x4(((_53[0] + _62[0]) + _85[0]) + _108[0], ((_53[1] + _62[1]) + _85[1]) + _108[1], ((_53[2] + _62[2]) + _85[2]) + _108[2], ((_53[3] + _62[3]) + _85[3]) + _108[3]);
    float4 _128 = float4(in.attPosition, 1.0);
    float4 _129 = _122 * _128;
    float4 _138 = _122 * float4(in.attNormal, 0.0);
    out.g_vary_WorldPosition = (buffer.u_Model * float4(_129.xyz, 1.0)).xyz;
    out.g_vary_WorldNormal = (buffer.u_TransposeInvModel * float4(_138.xyz, 0.0)).xyz;
    out.gl_Position = (buffer.u_MVP * _122) * _128;
    out.v_gl_pos = out.gl_Position;
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;       // Adjust clip-space for Metal
    return out;
}

